# Troubleshooting

1. **Your IntelliJ IDE freezes / hangs**

   Grab a terminal window and execute:
    ```bash
    killall idea
    ```
   Wait some seconds and restart IntelliJ.

2. **Browser accidentally closed, ILIAS Session lost**

    1. Click on the message's link in your left upper browser tab and unlock your session(s)
    2. Login again
    3. Go to top left Magazin -> (Baumansicht / tree view) -> Aktuelle Klausuren, select your exam, re-enter the access
       password and resume the test.

# Generate and open class/method javadoc for browsing

1. **By command in a terminal:**

   Grab a terminal in Idea (By lower left icon or Alt+F12) and issue / click green arrow `mvn javadoc:javadoc`:

    <pre>mvn javadoc:javadoc
    ...
    [<span style="color:blue;font-weight:bold;">INFO</span>] Executing tasks
    [<span style="color:orange;font-weight:bold;">WARNING</span>]  [echo] Javadoc root at <span style="color:blue;">file:///home/.../Exam/target/reports/apidocs/index.html</span>
    [<span style="color:blue;font-weight:bold;">INFO</span>] Executed tasks
    ...</pre>

2. **By Idea GUI:**

    a) Hit the Maven 
       <span style="font-size: x-large;font-style: italic;background: #F7F8Fa;color: #6C707E;">m</span> icon
       on top of Idea's right side panel

    b) Open the **sd1_20xxxxx entry**.

    c) Open Plugins

    d) Open Javadoc

    e) Double click on `javadoc:javadoc`

Click on or copy the <span style="color:blue;">file:///.../index.html</span> link opening your project's 
Javadoc root in your web browser.

# Implementation tasks

Your project's packages _typically_ contain implementation task packages:

- `de.hdm_stuttgart.mi.sd1.task1` (50 Points)

- `de.hdm_stuttgart.mi.sd1.task2` (20 points, more difficult)

Read the generated documentation and implement the skeleton methods and classes.

Your project's  `test` branch does contain corresponding unit tests for verifying your solutions' correctness.

# Hints

- Your score solely depends on the number of successfully executing unit tests. A »nearly correct« implementation failing
  with respect to a given unit tests will not contribute any points at all.

- General advice: Implement less but correctly.

- Mind special cases i.e. `null` variable values or null values being contained in arrays.

- In case of test failures both the IDEA debugger and logging statements are your friend.

Executing `de.hdm_stuttgart.mi.sd1.ShowReachedPoints` in your project's test branch as a Java application
(not as Junit test!) shows your number of points reached so far.

Do not model your implementations along unit test definitions i.e. avoid cheating this way! Such behaviour will be
regarded as an attempt at deception (Täuschungsversuch).

# Exam system upload

After finishing implementing:

1. Export this project by hitting **»File ➔ Export ➔ Project to Zip File«**.
2. Use a self-explanatory file name like e.g. `solution1.zip`.
3. Go to your exam browser window and upload `solution1.zip` .
4. Complete by  **clicking the »<span style="background: #527A35;color:white;">Speichern + weiter ➞ </span>«** button.
5. Hit **<span style="background: #446684;color:white;"> 🠬 Speichern + zurück</span>** and check if your
   upload is visible.
6. If you advance on implementing: Repeat steps 1. to 5.: Only the least uploaded `.zip` archive will become subject to
   marking.
