package de.hdm_stuttgart.mi.sd1.task1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.junit.Assert;
import org.junit.Test;

public class

A_PaymentTest extends ExaminationTestDefaults {


    public static final Logger log = LogManager.getLogger();


    static final public double DOUBLE_TEST_PRECISION_LIMIT = 1.E-13;
    @Test
    @Marking(points = 8)
    public void testFreeShippingPayment () {

        for (int orderSum = 5000; orderSum < 10000; orderSum++) {
            for (int day = 3; day < 100; day++) {
                test(orderSum / 100., orderSum / 100., day);
            }
            for (int day = 0; day <= 2; day++) {
                test(orderSum * 98 / 10000., orderSum / 100., day);
            }
        }
    }

    @Test
    @Marking(points = 8)
    public void testNonfreeShippingPayment () {

        for (int orderSum = 1; orderSum < 5000; orderSum++) {
            for (int day = 3; day < 100; day++) {
                test(orderSum / 100. + 6.50, orderSum / 100., day);
            }
            for (int day = 0; day <= 2; day++) {
                test(orderSum * 98 / 10000. + 6.50, orderSum / 100., day);
            }
        }
    }

    static private void test(final double expectedCosts, final double amount, int paymentDelay) {

        final double actualCosts = A_Payment.getBillingAmount(amount, paymentDelay);

        if (DOUBLE_TEST_PRECISION_LIMIT < Math.abs(actualCosts - expectedCosts) ) {
            final String message = "Order amount=" + amount + "€, payment delay=" + paymentDelay +
                    ". Wanna set a breakpoint to start debugging?";

            Assert.assertEquals(
                    message, expectedCosts,
                    A_Payment.getBillingAmount(amount, paymentDelay), DOUBLE_TEST_PRECISION_LIMIT);

        }
    }
}
