package de.hdm_stuttgart.mi.sd1.task1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import org.junit.Assert;
import org.junit.Test;
import static de.hdm_stuttgart.mi.sd1.task1.B_Irrigation.irrigationIsActive;

public class B_IrrigationTest  extends ExaminationTestDefaults {

    static private void test(final boolean expectedIrrigationState,
                             final int fromHour, final int toHour,
                             final int fromMinute,
                             final int toMinute) {

        for (int hour = fromHour; hour <= toHour; hour++) {
            for (int minute = fromMinute; minute <= toMinute; minute++) {

                final String msg = "At " + hour + ":" + minute + " Irrigation is supposed to be " +
                        (expectedIrrigationState ? "active" : "inactive") + ". Wanna set a breakpoint to start debugging?";

                final boolean actualIrrigationState = irrigationIsActive(hour, minute);

                if (expectedIrrigationState != actualIrrigationState) {
                    Assert.assertEquals(msg, expectedIrrigationState, actualIrrigationState);
                }
            }
        }
    }

    static private void test(final boolean expectedIrrigationState,
                             final int fromHour, final int toHour) {
        test(expectedIrrigationState, fromHour, toHour, 0, 59);
    }

    static private void test(final boolean expectedIrrigationState,
                             final int hour,
                             final int fromMinute,
                             final int toMinute) {
        test(expectedIrrigationState, hour, hour, fromMinute, toMinute);
    }

    @Test
    @Marking(points = 13)
    public void testIrrigation () {

        test(false, 0, 4); // 0:00 till 4:59
        test(true, 5, 5); // 5:00 till 5:59
        test(true, 6, 0, 30); // 6:00 till 6:30
        test(false, 6, 31, 59); // 6:31 till 6:59
        test(false, 7, 20); // 7:00 till 20:59
        test(false, 21, 0, 29); // 21:00 till 21:29
        test(true, 21, 30, 59); // 21:30 till 21:59
        test(true, 22, 0, 30); // 22:00 till 22:30
        test(false, 22, 31, 59); // 22:31 till 22:59
        test(false, 23, 23); // 23:00 till 23:59
    }
}
