package de.hdm_stuttgart.mi.sd1.task1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

import static de.hdm_stuttgart.mi.sd1.task1.C_Switch.switchFirstAndSurname;


@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class
C_SwitchTest extends ExaminationTestDefaults {

    @Test
    @Marking(points = 2)
    public void test_050_null() {
        Assert.assertNull(switchFirstAndSurname(null));
    }

    @Test
    @Marking(points = 2)
    public void test_100_error() {
        Assert.assertNull(switchFirstAndSurname(""));
        Assert.assertNull(switchFirstAndSurname(" "));
        Assert.assertNull(switchFirstAndSurname(" test "));
        Assert.assertNull(switchFirstAndSurname("Tucholski;Kurt"));
        Assert.assertNull(switchFirstAndSurname("Macdonald Amy"));
        Assert.assertNull(switchFirstAndSurname("Keynes, John, Maynard"));
        Assert.assertNull(switchFirstAndSurname(",Hauser Kaspar"));
        Assert.assertNull(switchFirstAndSurname("Hauser Kaspar,"));
        Assert.assertNull(switchFirstAndSurname("Hauser, Kaspar,"));
        Assert.assertNull(switchFirstAndSurname(",Hauser, Kaspar"));
        Assert.assertNull(switchFirstAndSurname(",Hauser  , Kaspar"));
        Assert.assertNull(switchFirstAndSurname(",,,,,,,"));
    }

    @Test
    @Marking(points = 2)
    public void test_200_minNoWhite() {
        Assert.assertEquals("R D", switchFirstAndSurname("D,R"));
        Assert.assertEquals("Y X", switchFirstAndSurname("X,Y"));
    }

    @Test
    @Marking(points = 2)
    public void test_210_minWhite() {
        Assert.assertEquals("q P", switchFirstAndSurname("P, q"));
        Assert.assertEquals("z l", switchFirstAndSurname("l,   z"));
        Assert.assertEquals("T d", switchFirstAndSurname("d,   T  "));
        Assert.assertEquals("k p", switchFirstAndSurname("    p,k"));
        Assert.assertEquals("u l  J", switchFirstAndSurname(" l  J   ,    u "));
    }

    @Test
    @Marking(points = 2)
    public void test_300_regularNoWhite() {
        Assert.assertEquals("Miles Davis", switchFirstAndSurname("Davis,Miles"));
        Assert.assertEquals("Hannah Arendt", switchFirstAndSurname("Arendt,Hannah"));
        Assert.assertEquals("Simone de Beauvoir", switchFirstAndSurname("de Beauvoir,Simone"));
    }

    @Test
    @Marking(points = 2)
    public void test_300_regularWhite() {
        Assert.assertEquals("Martin Luther King", switchFirstAndSurname("   King, Martin Luther"));
        Assert.assertEquals("Janis Joplin", switchFirstAndSurname("  Joplin   ,Janis "));
        Assert.assertEquals("John von Neumann", switchFirstAndSurname("von Neumann ,   John   "));
    }
}
